<template>
  <div class="view-table-content">
    <div class="view-dataSpecies-left">
      <MenuTree :currentNodeKey="currentNodeKey" nodeKey="id" :treedata="menuTreeData" @TreeNodeclick="treeNodeClick" v-bind="treeObj"> </MenuTree>
    </div>
    <div class="view-dataSpecies-right">
      <div class="view-dataType-title">
        <div class="view-dataType-title-btn">
          <el-button type="success" @click="openDialog()" :disabled="currentNode && currentNode.type == 0">新增</el-button>
          <el-button type="warning" @click="remove(tableCheckItems)" :disabled="tableCheckItems.length == 0">删除</el-button>
        </div>
        <div class="view-dataType-title-search">
          <el-input placeholder="请输入关键字" v-model="keyWord" class="input1">
            <el-button slot="append" icon="el-icon-search" @click="searchClick"></el-button>
          </el-input>
        </div>
      </div>
      <div class="view-dataType-table">
        <LTable ref="table" @selection-change="selection" :defaultFetch="false" :fetch="fetch" :columns="columns" :dataSource="tableData" :options="options" :pagination="tableRequset"></LTable>
      </div>
      <!-- 添加或修改维修信息对话框 -->
      <el-dialog :title="dialogTitle" :visible.sync="dialogVisible" width="600px" :before-close="handleClose">
        <el-form ref="form" :model="form" label-width="80px">
          <el-form-item label="飞机编码" prop="aircraftCode">
            <el-input v-model="form.aircraftCode" placeholder="请输入飞机编码" />
          </el-form-item>
          <el-form-item label="故障代码" prop="faultCode">
            <el-input v-model="form.faultCode" placeholder="请输入故障代码" />
          </el-form-item>
          <el-form-item label="故障名称" prop="faultName">
            <el-input v-model="form.faultName" placeholder="请输入故障名称" />
          </el-form-item>
          <el-form-item label="故障位置" prop="location">
            <el-input v-model="form.location" placeholder="请输入故障位置" />
          </el-form-item>
          <el-form-item label="故障等级" prop="level">
            <el-input v-model="form.level" placeholder="请输入故障等级" />
          </el-form-item>
          <el-form-item label="故障发生时间" prop="faultDate">
            <el-date-picker clearable v-model="form.faultDate" type="date" value-format="YYYY-MM-DD" placeholder="请选择故障发生时间"> </el-date-picker>
          </el-form-item>
          <el-form-item label="故障现象" prop="symptoms">
            <el-input v-model="form.symptoms" placeholder="请输入故障现象" />
          </el-form-item>
          <el-form-item label="故障原因" prop="faultCause">
            <el-input v-model="form.faultCause" placeholder="请输入故障原因" />
          </el-form-item>
          <el-form-item label="维修负责人" prop="supervisor">
            <el-input v-model="form.supervisor" placeholder="请输入维修负责人" />
          </el-form-item>
          <el-form-item label="维修时间" prop="maintenanceTime">
            <el-date-picker clearable v-model="form.maintenanceTime" type="date" value-format="YYYY-MM-DD" placeholder="请选择维修时间"> </el-date-picker>
          </el-form-item>
          <el-form-item label="换件前器材编码" prop="beforeEquipmentCode">
            <el-input v-model="form.beforeEquipmentCode" placeholder="请输入换件前器材编码" />
          </el-form-item>
          <el-form-item label="换件前器材名称" prop="beforeEquipmentName">
            <el-input v-model="form.beforeEquipmentName" placeholder="请输入换件前器材名称" />
          </el-form-item>
          <el-form-item label="换件前规格型号" prop="beforeModelNumber">
            <el-input v-model="form.beforeModelNumber" placeholder="请输入换件前规格型号" />
          </el-form-item>
          <el-form-item label="换件后器材编码" prop="afterEquipmentCode1">
            <el-input v-model="form.afterEquipmentCode1" placeholder="请输入换件后器材编码" />
          </el-form-item>
          <el-form-item label="换件后器材名称" prop="afterEquipmentName1">
            <el-input v-model="form.afterEquipmentName1" placeholder="请输入换件后器材名称" />
          </el-form-item>
          <el-form-item label="换件后规格型号" prop="afterModelNumber1">
            <el-input v-model="form.afterModelNumber1" placeholder="请输入换件后规格型号" />
          </el-form-item>
          <el-form-item label="更换数量" prop="quantity">
            <el-input v-model="form.quantity" placeholder="请输入更换数量" />
          </el-form-item>
          <el-form-item label="备注" prop="remarks">
            <el-input v-model="form.remarks" type="textarea" :rows="2" placeholder="请输入备注" />
          </el-form-item>
        </el-form>

        <span slot="footer" class="dialog-footer">
          <el-button @click="handleClose">取 消</el-button>
          <el-button type="primary" @click="submit">确 定</el-button>
        </span>
      </el-dialog>
    </div>
  </div>
</template>

<script>
import { getMaintenance, getAircaftTypeAndModelTree, addMaintenance, updateMaintenance, removeMaintenance } from '@/api/als/maintenance'
import { deepClone, debounce } from '@/utils/index'
export default {
  name: 'Maintenance',
  components: {},
  data() {
    // 这里存放数据
    return {
      dialogTitle: '新增',
      dialogVisible: false,
      keyWord: '',
      aircaftModelIdList: [],
      currentNodeKey: null,
      currentNode: null,
      menuTreeData: [],
      treeObj: {
        title: '所属机种',
        activityheight: '275px',
        searchIcon: false,
        configure: {
          children: 'children',
          label: 'label'
        }
      },
      typeTree: {
        children: 'children',
        label: 'label'
      },
      searchValue: '',
      columns: [
        { prop: 'id', label: '编号' },
        {
          prop: 'aircraftCode',
          label: '飞机编码'
        },
        {
          prop: 'faultCode',
          label: '故障代码'
        },
        {
          prop: 'faultName',
          label: '故障名称'
        },
        {
          prop: 'location',
          label: '故障位置'
        },
        {
          prop: 'level',
          label: '故障等级'
        },
        {
          prop: 'faultDate',
          label: '故障发生时间'
        },
        {
          prop: 'symptoms',
          label: '故障现象'
        },
        {
          prop: 'faultCause',
          label: '故障原因'
        },
        {
          prop: 'status',
          label: '维修结果'
        },
        {
          prop: 'supervisor',
          label: '维修负责人'
        },
        {
          prop: 'maintenanceTime',
          label: '维修时间'
        },
        {
          prop: 'beforeEquipmentCode',
          label: '换件前器材编码'
        },
        {
          prop: 'beforeEquipmentName',
          label: '换件前器材名称'
        },
        {
          prop: 'beforeModelNumber',
          label: '换件前规格型号'
        },
        {
          prop: 'afterEquipmentCode1',
          label: '换件后器材编码'
        },
        {
          prop: 'afterEquipmentName1',
          label: '换件后器材名称'
        },
        {
          prop: 'afterModelNumber1',
          label: '换件后规格型号'
        },
        {
          prop: 'quantity',
          label: '更换数量'
        },
        {
          prop: 'remarks',
          label: '备注'
        },
        {
          button: true,
          label: '操作',
          width: '240px',
          group: [
            {
              name: '编辑',
              type: 'text',
              round: false,
              plain: false,
              onClick: (row, index, scope) => {
                _this.handUpdate(row)
              }
            },
            {
              name: '删除',
              type: 'text',
              round: false,
              plain: false,
              onClick: (row, index, scope) => {
                _this.remove([row])
              }
            }
          ]
        }
      ],
      options: {
        stripe: true, // 斑马纹
        mutiSelect: true, // 多选框
        index: false, // 显示序号， 多选则 mutiSelect
        loading: false, // 表格动画
        initTable: false, // 是否一挂载就加载数据
        border: true,
        height: 'calc(100vh - 300px)'
      },
      tableCheckItems: [],
      tableData: [],
      tableRequset: {
        total: 0,
        pageIndex: 1,
        pageSize: 10,
        searchValue: ''
      },
      form: {
        id: '',
        aircraftCode: '',
        faultCode: '',
        faultName: '',
        location: '',
        level: '',
        faultDate: '',
        symptoms: '',
        faultCause: '',
        status: '',
        supervisor: '',
        maintenanceTime: '',
        beforeEquipmentCode: '',
        beforeEquipmentName: '',
        beforeModelNumber: '',
        afterEquipmentCode1: '',
        afterEquipmentName1: '',
        afterModelNumber1: '',
        quantity: '',
        remarks: '',
        tenantId: '',
        version: '',
        delFlag: '',
        createBy: '',
        createTime: '',
        updateBy: '',
        updateTime: ''
      },
      debounceFn: debounce(this.fetch, 500)
    }
  },
  watch: {
    keyWord() {
      this.tableRequset.pageIndex = 1
      this.debounceFn()
    }
  },
  mounted() {
    this.getAircaftTypeAndModelTreeAPI()
  },
  methods: {
    async getAircaftTypeAndModelTreeAPI(params) {
      const { data } = await getAircaftTypeAndModelTree(params)
      this.menuTreeData = data
      if (data.length) {
        this.currentNodeKey = data[0].value
        this.currentNode = data[0]
        this.aircaftModelIdList = this.getTreeLeafData(data[0]?.children).map((e) => e.id)
        this.getMaintenanceAPI({ aircaftModelIdList: this.aircaftModelIdList })
      }
    },

    async removeMaintenanceAPI(params) {
      try {
        const { success } = await removeMaintenance(params)
        if (success) {
          this.$message({
            type: 'success',
            message: '操作成功!'
          })
          await this.getMaintenanceAPI({ aircaftModelIdList: this.aircaftModelIdList })
          this.handleClose()
        }
      } catch (error) {}
    },

    getTreeLeafData(list) {
      const newArr = []
      function getLeaf(data, arr) {
        data.forEach((e) => {
          if (e.type === 1) {
            arr.push(e)
          }
          if (e.children.length) {
            getLeaf(e.children, arr)
          }
        })
      }
      getLeaf(list, newArr)
      return newArr
    },

    async getMaintenanceAPI(params) {
      if (this.$refs.table) this.$refs.table.clearSelection()
      const { keyWord } = this
      const { pageSize, pageIndex } = this.tableRequset
      const {
        data: { list, total }
      } = await getMaintenance({ pageSize, pageIndex, keyWord, ...params })
      this.tableData = list
      this.tableRequset.total = total
    },

    fetch() {
      this.getMaintenanceAPI({ aircaftModelIdList: this.aircaftModelIdList })
    },

    searchClick() {
      this.getMaintenanceAPI({ aircaftModelIdList: this.aircaftModelIdList })
    },

    async addMaintenanceAPI() {
      try {
        delete this.form.aircaftModelName
        const { success } = await addMaintenance({ ...this.form })
        if (success) {
          this.$message({
            type: 'success',
            message: '操作成功!'
          })
          this.getMaintenanceAPI({ aircaftModelIdList: this.aircaftModelIdList })
        }
      } catch (error) {}
    },

    async updateMaintenanceAPI() {
      try {
        const { success } = await updateMaintenance({ ...this.form })
        if (success) {
          this.$message({
            type: 'success',
            message: '操作成功!'
          })
          this.getMaintenanceAPI({ aircaftModelIdList: this.aircaftModelIdList })
        }
      } catch (error) {}
    },

    treeNodeClick(data) {
      this.$refs.table.clearSelection()
      this.currentNodeKey = data.id
      this.currentNode = data
      this.aircaftModelIdList = this.getTreeLeafData(data.children.length ? data.children : [data]).map((e) => e.id)
      this.getMaintenanceAPI({ aircaftModelIdList: this.aircaftModelIdList })
    },

    openDialog() {
      this.dialogTitle = '新增'
      this.dialogVisible = true
      this.form.aircaftModelName = this.currentNode.label
      this.form.aircaftModelId = this.currentNode.id
    },

    handleClose() {
      this.dialogVisible = false
      this.form = {
        id: '',
        aircraftCode: '',
        faultCode: '',
        faultName: '',
        location: '',
        level: '',
        faultDate: '',
        symptoms: '',
        faultCause: '',
        status: '',
        supervisor: '',
        maintenanceTime: '',
        beforeEquipmentCode: '',
        beforeEquipmentName: '',
        beforeModelNumber: '',
        afterEquipmentCode1: '',
        afterEquipmentName1: '',
        afterModelNumber1: '',
        quantity: '',
        remarks: '',
        tenantId: '',
        version: '',
        delFlag: '',
        createBy: '',
        createTime: '',
        updateBy: '',
        updateTime: ''
      }
    },

    handUpdate(row) {
      this.dialogTitle = '编辑'
      this.form = deepClone(row)
      this.dialogVisible = true
    },

    submit() {
      switch (this.dialogTitle) {
        case '编辑':
          this.updateMaintenanceAPI()
          this.handleClose()
          break
        case '新增':
          this.addMaintenanceAPI()
          this.handleClose()
          break
      }
    },

    selection(val) {
      this.tableCheckItems = val
    },

    remove(row) {
      this.$confirm('是否删除该数据', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      })
        .then(() => {
          this.removeMaintenanceAPI(row.map((e) => e.id))
        })
        .catch(() => {})
    }
  }
}
</script>

<style lang="scss" scoped>
@import '../index.scss';
</style>
